/*
** wavwindow.c for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Tue Feb 16 23:15:21 1999 Rmi Coupet
** Last update Thu Mar 18 18:27:43 1999 Rmi Coupet
*/

#include <stdio.h>
#include "wavwindow.h"

/* ----------- PIXMAPS -------------- */

#include "xpms/logo.xpm"
#include "xpms/pause_play.xpm"
#include "xpms/pause_play_light.xpm"
#include "xpms/play.xpm"
#include "xpms/play_light.xpm"
#include "xpms/stop_play.xpm"
#include "xpms/stop_play_light.xpm"
#include "xpms/export.xpm"
#include "xpms/export_light.xpm"
#include "xpms/invert.xpm"
#include "xpms/invert_light.xpm"

/* ----------- PIXMAPS -------------- */

static void	wavwin_class_init		(WavwinClass	*klass) ;
static void	wavwin_init			(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_notebook	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_vbox1	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_vbox2	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_hbox1	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_hbox2	(Wavwin		*ww) ;
GtkWidget	*create_standard_page		(Wavwin		*ww) ;
GtkWidget	*create_volume_page		(Wavwin		*ww) ;
GtkWidget	*create_panning_page		(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_menubar	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_toolbar	(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_logo		(Wavwin		*ww) ;
GtkWidget	*create_wav_editor_progress_bar	(Wavwin		*ww) ;


//static gint wavwin_signals[LAST_SIGNAL] = { 0 };

typedef struct s_pix_list t_pix_list ;
struct 	s_pix_list 
{
  char	**standard ;
  char	**light ;
} ;


guint wavwin_get_type (void)
{
  static guint ww_type = 0;

  if (!ww_type)
  {
    GtkTypeInfo ww_info =
    {
      "Wavwin",
      sizeof (Wavwin),
      sizeof (WavwinClass),
      (GtkClassInitFunc) wavwin_class_init,
      (GtkObjectInitFunc) wavwin_init,
      (GtkArgSetFunc) NULL
//      (GtkArgGetFunc) NULL
    };

    ww_type = gtk_type_unique (gtk_vbox_get_type (), &ww_info);
  }
  
  return ww_type;
}

static void wavwin_class_init (class)
WavwinClass *class ;
{
  GtkObjectClass *object_class;
  
  object_class = (GtkObjectClass*) class;  
  class->wavwin = NULL;
}

GtkWidget *wavwin_new(void)
{
  return GTK_WIDGET ( gtk_type_new (wavwin_get_type ()));
}

/* 
** The function which create the base of the wavwin object.
*/

static void	wavwin_init (ww)
Wavwin		*ww ;
{
  GtkWidget *table ;
  
  ww->is_the_button_pressed = FALSE ;
  ww->invert = FALSE ;
  table = gtk_table_new(8, 12, FALSE) ;
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_toolbar(ww),
		   3, 9, 0, 1, GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_menubar(ww),
		   0, 3, 0, 1, GTK_EXPAND, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_logo(ww),
		   9, 12, 0, 1, GTK_EXPAND, 
		   GTK_EXPAND | GTK_FILL, 0, 0);
/*    gtk_table_attach(GTK_TABLE(table), create_wav_editor_vbox1(ww), */
/*    		   10, 12, 1, 4, GTK_EXPAND,  */
/*  		   GTK_EXPAND | GTK_FILL, 0, 0); */
/*    gtk_table_attach(GTK_TABLE(table), create_wav_editor_vbox2(ww), */
/*    		   10, 12, 4, 6, GTK_EXPAND, GTK_EXPAND, 0, 0); */
  gtk_table_attach(GTK_TABLE (table), create_wav_editor_progress_bar(ww),
		   0, 12, 6, 7, GTK_EXPAND | GTK_FILL, GTK_EXPAND,0,0);
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_hbox1(ww),
		   0, 2, 7, 8, GTK_EXPAND, GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_hbox2(ww),
  		   4, 12, 7, 8, GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), create_wav_editor_notebook(ww),
  		   0, 12, 1, 6, GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_show(table);
  gtk_box_pack_start(GTK_BOX (ww), table, TRUE, TRUE, 0);
}


GtkWidget	*create_wav_editor_logo(ww)
Wavwin		*ww ;
{
  return new_pix_from_data (MainWindow, logo_xpm);
}


GtkWidget	*create_wav_editor_menubar(ww)
Wavwin		*ww ;
{ 
  ww->menubar =  gtk_menu_bar_new() ; 
  gtk_widget_show(ww->menubar) ;
  gtk_widget_set_name(ww->menubar, "wav menubar");
  return ww->menubar ;
}


GtkWidget	*create_wav_editor_toolbar(ww)
Wavwin		*ww ;
{
  GSList	*group1 ;
  int		i ;
  char		*name[CHANNELS] = {"select left", "select right"};
  char		*name2[CHANNELS] = {"Histogram", "Curve"};

  ww->toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,
				GTK_TOOLBAR_ICONS);
  group1 = NULL ;
  for (i = 0; i < TOOLBAR_REPRESENTATION; i++){  
    ww->toolbar_button[i] = gtk_radio_button_new(group1);
    gtk_toolbar_append_widget(GTK_TOOLBAR (ww->toolbar), 
			      ww->toolbar_button[i],
			      name2[i], NULL);
    gtk_widget_show(ww->toolbar_button[i]);
    group1 = gtk_radio_button_group(GTK_RADIO_BUTTON (ww->toolbar_button[i]));
  }
  
  for (i=0; i < CHANNELS; i++)
  {
    ww->chose_channel[i] = gtk_toggle_button_new() ;
    gtk_widget_set_usize(ww->chose_channel[i], 22, 22) ;
    gtk_toolbar_append_widget(GTK_TOOLBAR (ww->toolbar), 
			      ww->chose_channel[i],
			      name[i], NULL);
    gtk_widget_show(ww->chose_channel[i]);
  }

  ww->invert_button = 
    Create_Toggle_Button_with_pixmap_label("",
					   invert_xpm,
					   invert_light_xpm,
					   MainWindow) ;
  gtk_toolbar_append_widget(GTK_TOOLBAR (ww->toolbar), 
			    ww->invert_button, "Invert Selection", NULL);
  gtk_widget_show(ww->invert_button) ;

  ww->export_button = Create_Button_with_pixmap_label("Export", export_xpm,
						      export_light_xpm, MainWindow) ;
  gtk_toolbar_append_widget(GTK_TOOLBAR (ww->toolbar), 
			    ww->export_button, "Export in Mixer", NULL);
  gtk_widget_show(ww->export_button) ;

  gtk_widget_set_name(ww->toolbar, "wav toolbar");
  gtk_widget_show(ww->toolbar) ;
  return ww->toolbar ;
}


GtkWidget	*create_standard_page(ww)
Wavwin		*ww ;
{
  GtkWidget *table ;

  table = gtk_table_new(5, 9, FALSE) ;
  gtk_table_attach(GTK_TABLE(table), ww->wve[STANDARD],
  		   0, 8, 0, 4, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  WAVEDITOR (ww->wve[STANDARD])->pixmap[0] = NULL ;
  WAVEDITOR (ww->wve[STANDARD])->pixmap[1] = NULL ;
  gtk_widget_show(ww->wve[STANDARD]) ;
  gtk_widget_show(table) ;
  return table ;
}


GtkWidget	*create_panning_page(ww)
Wavwin		*ww ;
{
  GtkWidget *table ;

  table = gtk_table_new(5, 9, FALSE) ;
  gtk_table_attach(GTK_TABLE(table), ww->wve[PANNING],
  		   0, 8, 0, 4, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_show(ww->wve[PANNING]) ;
  WAVEDITOR (ww->wve[PANNING])->pixmap[0] = NULL ;
  WAVEDITOR (ww->wve[PANNING])->pixmap[1] = NULL ;
  gtk_widget_show(table) ;
  return table ;
}


GtkWidget	*create_volume_page(ww)
Wavwin		*ww ;
{
  GtkWidget *table ;

  table = gtk_table_new(5, 9, FALSE) ;
  gtk_table_attach(GTK_TABLE(table), ww->wve[VOLUME],
  		   0, 8, 0, 4, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_show(ww->wve[VOLUME]) ;
  WAVEDITOR (ww->wve[VOLUME])->pixmap[0] = NULL ;
  WAVEDITOR (ww->wve[VOLUME])->pixmap[1] = NULL ;
  gtk_widget_show(table) ;
  return table ;
}


GtkWidget	*create_wav_editor_notebook(ww)
Wavwin		*ww ;
{
  GtkWidget	*label ;
  GtkWidget	*table ;
  
  ww->wve[STANDARD] = waveditor_new();
  ww->wve[VOLUME] = waveditor_new();
  ww->wve[PANNING] = waveditor_new();
  ww->notebook = gtk_notebook_new() ;

  label = gtk_label_new("STANDARD") ;
  table = create_standard_page(ww) ;
  gtk_notebook_append_page(GTK_NOTEBOOK (ww->notebook), table, label);
  
  label = gtk_label_new("VOLUME ENVELOPE") ;
  table = create_volume_page(ww) ;
  gtk_notebook_append_page(GTK_NOTEBOOK (ww->notebook), table, label);

  label = gtk_label_new("PANNING ENVELOPE") ;
  table = create_panning_page(ww) ;
  gtk_notebook_append_page(GTK_NOTEBOOK (ww->notebook), table, label);

  //gtk_signal_connect_object(GTK_OBJECT (ww->notebook), "switch_page" ,
  //	    GTK_SIGNAL_FUNC (switch_notebook), GTK_OBJECT (ww)) ;

  gtk_widget_show(ww->notebook) ;
  return ww->notebook ;
}

 
GtkWidget	*create_wav_editor_vbox1(ww)
Wavwin		*ww;
{
  GtkWidget	*vbox ;
  int		i ;
  
  vbox = gtk_vbox_new(FALSE, 0) ;
  for (i = 0; i < FILTERS_BUTTONS; i++){
    ww->filters_button[i] = gtk_button_new() ;
    gtk_widget_set_usize(ww->filters_button[i], 75, 25);
    gtk_widget_show(ww->filters_button[i]) ;
    gtk_box_pack_start(GTK_BOX (vbox), ww->filters_button[i], 
		       TRUE, TRUE, 0) ;
  }
  gtk_widget_show(vbox) ;
  return vbox ;
}

GtkWidget	*create_wav_editor_vbox2(ww)
Wavwin		*ww;
{
  GtkWidget *vbox ;
  
  vbox = gtk_vbox_new(FALSE, 0) ;
  gtk_widget_show(vbox) ;
  return vbox ;
}

GtkWidget	*create_wav_editor_hbox1(ww)
Wavwin		*ww;
{
  GtkWidget *hbox ;
  int i ;
  t_pix_list	pix[] = { 
    {play_xpm, play_light_xpm},
    {pause_play_xpm, pause_play_light_xpm},
    {stop_play_xpm, stop_play_light_xpm}
  };

  hbox = gtk_hbox_new(TRUE, 0) ;
  for (i = 0; i < WAVPLAYER_BUTTONS; i++){
    ww->play_button[i] = Create_Button_with_pixmap_label("",
							 pix[i].standard,
							 pix[i].light,
							 MainWindow) ;
    gtk_widget_set_usize(ww->play_button[i], PLAY_BUTTON_SIZE, 
			 PLAY_BUTTON_SIZE) ;
    gtk_widget_show(ww->play_button[i]) ;
    gtk_box_pack_start(GTK_BOX (hbox), ww->play_button[i], FALSE, FALSE, 0) ;
  }
  gtk_widget_show(hbox) ;
  return hbox ;
}

GtkWidget	*create_wav_editor_hbox2(ww)
Wavwin		*ww;
{
  GtkWidget *hbox ;
  int i ;
  
  hbox = gtk_hbox_new(TRUE, 0) ;
  for (i = 0; i < NAVIGATION_BUTTONS; i++){
    ww->navigation_button[i] = gtk_button_new() ;
    gtk_widget_show(ww->navigation_button[i]) ;
    gtk_widget_set_usize(ww->navigation_button[i], 40, PLAY_BUTTON_SIZE);
    gtk_box_pack_start(GTK_BOX (hbox), ww->navigation_button[i], 
		       TRUE, TRUE, 0) ;
  }
  gtk_widget_show(hbox) ;
  return hbox ;
}


GtkWidget	*create_wav_editor_progress_bar(ww)
Wavwin		*ww ;
{
  ww->progress_bar = gtk_progress_bar_new() ;
  gtk_widget_show(ww->progress_bar) ;
  return ww->progress_bar ;
}










